﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;


using System.Runtime.InteropServices; // needed for DllImport
using System.Text; // needed for StringBuilder Class
using System.IO;

// Please read the included file "important_notes_for_NET_developers_on_using_WSQ_image_library.html"
// or the page: 
// http://www.cognaxon.com/index.php?page=wsqlib_NETnotes
// FAQ (Frequently Asked Questions)
// for .NET developers on using WSQ image library


namespace wsq_demo
{
    public partial class Form1 : Form
    {

        private WSQImageLibraryNativeMethods32 WSQ_library_native_methods;

		static IntPtr bp;
		static System.Drawing.Bitmap b;
		static byte[] input_data_stream;
		static byte[] input_data_stream2;
		static byte[] output_data_stream;
		static byte[] output_data_stream2;
		static Int32 width;
		static Int32 height;
		static Int32 ppi;
		static double bitrate;
		static String comment_text;
		private UTF8Encoding utf8 = new UTF8Encoding();
		

        public Form1()
        {

            comment_text = String.Empty; //need to initialize comment_text in order to avoid crashing

            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
            WSQ_library_native_methods = new WSQImageLibraryNativeMethods32();

        }



        // To call functions from WSQ_library.dll
		// you can use the methods from wrapper class WSQImageLibraryNativeMethods32
		// or you can use function prototypes provided below 

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern IntPtr _CreateBMPFromFile(byte[] filename);

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _SaveBMPToFile(IntPtr hBitmap, byte[] filename, Int32 filetype);

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _RegisterWSQ();

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _SetShowFilePropertiesDialog(Int32 file_properties_dialog);

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _ShowFileConverter();

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern IntPtr _ConvertHBITMAPtoGrayScale256(IntPtr hBitmap);

		[DllImport("WSQ_library.dll", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
		public static extern void _SaveHBITMAPtoFileAsGrayScale256BMP(IntPtr hBitmap, byte[] filename);


        private void buttonOpen_Click(object sender, EventArgs e)
        {

            OpenFileDialog ofd = new OpenFileDialog();

            ofd.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;" +
"*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;" +
"*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp|" +
"FBI Wavelet Scalar Quantization (*.wsq)|*.wsq|" +
"Windows bitmaps (*.bmp)|*.bmp|" +
"Macintosh TIFF images (*.tiff)|*.tiff|" +
"PC TIFF images (*.tif)|*.tif|" +
"JPG images (*.jpg)|*.jpg|" +
"JPEG-2000 Part-1 (*.jp2)|*.jp2|" +
"JPEG-2000 Code Stream (*.jpc)|*.jpc|" +
"JPE images (*.jpe)|*.jpe|" +
"JPEG images (*.jpeg)|*.jpeg|" +
"Portable network graphic images (*.png)|*.png" +
"Compuserve Graphic Interchange Format(*.gif)|*gif|" +
"Paintshop Pro images (*.psp)|*.psp|" +
"JFIF images (*.jfif)|*.jfif|" +
"Run length encoded Windows bitmaps (*.rle)|*.rle|" +
"Device independant Windows bitmaps (*.dib)|*.dib|" +
"Truevision images (*.win)|*.win|" +
"Truevision images (*.vst)|*.vst|" +
"Truevision images (*.vda)|*.vda|" +
"Truevision images (*.tga)|*.tga|" +
"Truevision images (*.icb)|*.icb|" +
"GFI fax images (*.fax)|*.fax" +
"Encapsulated Postscript images (*.eps)|*.eps|" +
"ZSoft Paintbrush images (*.pcx)|*.pcx|" +
"ZSoft Paintbrush images (*.pcc)|*.pcc|" +
"Word 5.x screen capture images (*.scr)|*.scr|" +
"Alias/Wavefront images (*.rpf)|*.rpf|" +
"Alias/Wavefront images (*.rla)|*.rla|" +
"SGI true color images (*.sgi)|*.sgi|" +
"SGI true color images with alpha (*.rgba)|*.rgba|" +
"SGI true color images (*.rgb)|*.rgb|" +
"SGI black/white images (*.bw)|*.bw|" +
"Photoshop images (*.psd)|*.psd|" +
"Photoshop images (*.pdd)|*.pdd|" +
"Portable pixel map images (*.ppm)|*.ppm|" +
"Portable gray map images (*.pgm)|*.pgm|" +
"Portable bitmap images (*.pbm)|*.pbm|" +
"Autodesk images (*.cel)|*.cel|" +
"Autodesk images (*.pic)|*.pic|" +
"Kodak Photo-CD images (*.pcd)|*.pcd|" +
"Dr. Halo images (*.cut)|*.cut|" +
"Amiga Bitmap Graphic (8 bits)|*.iff|" +
"Windows icons (*.ico)|*.ico|" +
"Windows metafiles (*.wmf)|*.wmf|" +
"Windows enhanced meta files (*.emf)|*.emf";

            ofd.FilterIndex = 1;
            if (ofd.ShowDialog() != DialogResult.OK)
            {
                return;
            }

            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //bp = _CreateBMPFromFile(utf8.GetBytes(ofd.FileName));
            bp = WSQ_library_native_methods.pCreateBMPFromFile(ofd.FileName);
            b = Image.FromHbitmap(bp);
            OutputPicture.Image = b;

            Int32 h = OutputPicture.Image.Height;
            Int32 w = OutputPicture.Image.Width;
            OutputPicture.SetBounds(0, 0, w, h);

            buttonSave.Enabled = true;



        }

        private void buttonSave_Click(object sender, EventArgs e)
        {

            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "WSQ Files (*.wsq)|*.wsq|" + // 1
"Windows BMP (*.bmp)|*.bmp|" + // 2
"TIFF Files (*.tif)|*.tif|" + //3
"PNG Files (*.png)|*.png|" + //4 
"JPEG Files (*.jpg)|*.jpg|" + // 5
"Targa Files (*.tga)|*.tga|" + // 6
"SGI Files (*.rgb)|*.rgb|" + // 7
"JPEG-2000 Part-1 (*.jp2)|*.jp2|" + // 8
"JPEG-2000 Code Stream (*.jpc)|*.jpc|" + // 9
"PBM - Portable Bitmap Format (*.pbm)|*.pbm|" + // 10
"PGM - Portable Graymap Format (*.pgm)|*.pgm|" + // 11
"PPM - Portable Pixmap Format (*.ppm)|*.ppm"; // 12

            sfd.FilterIndex = 1;
            if (sfd.ShowDialog() != DialogResult.OK)
            {
                return;
            }

            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //_SetShowFilePropertiesDialog(1);
            WSQ_library_native_methods.pSetShowFilePropertiesDialog(1);

            Bitmap b;
            IntPtr bp;

            b = new Bitmap(OutputPicture.Image);
            bp = b.GetHbitmap();

            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //_SaveBMPToFile(bp, utf8.GetBytes(sfd.FileName), sfd.FilterIndex);
            WSQ_library_native_methods.pSaveBMPToFile(bp, sfd.FileName, sfd.FilterIndex);

        }


        private void buttonRegister_Click(object sender, EventArgs e)
        {
            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //_RegisterWSQ();
            WSQ_library_native_methods.pRegisterWSQ();
        }

        private void buttonWSQtoStream_Click(object sender, EventArgs e)
        {


            OpenFileDialog ofd = new OpenFileDialog();

            ofd.Filter = "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq";

            ofd.FilterIndex = 1;
            if (ofd.ShowDialog() != DialogResult.OK)
            {
                return;
            }

            FileInfo fInfo = new FileInfo(ofd.FileName);
            long input_stream_length = fInfo.Length;
            FileStream fStream = new FileStream(ofd.FileName, FileMode.Open, FileAccess.Read);
            BinaryReader br = new BinaryReader(fStream);

            input_data_stream = br.ReadBytes((int)input_stream_length);

            WSQ_library_native_methods.pWSQ_decode_stream(input_data_stream, (int)input_stream_length,
                out output_data_stream, out width, out height, out ppi, out comment_text);

            //Converts WSQ compressed byte array into HBITMAP for showing on screen
            bp = WSQ_library_native_methods.pCreateBMPFromWSQByteArray(input_data_stream, (int)input_stream_length);
            b = Image.FromHbitmap(bp);
            OutputPicture.Image = b;

            Int32 h = OutputPicture.Image.Height;
            Int32 w = OutputPicture.Image.Width;
            OutputPicture.SetBounds(0, 0, w, h);

            int output_data_stream_length = height * width;

            // Saves WSQ compressed byte array to an image file.
            //WSQ_library_native_methods.pSaveWSQByteArrayToImageFile(input_data_stream, (int)input_stream_length, "C:\\OutputDirectory\\output.jpg", 5);


            MessageBox.Show("WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.");

            br.Close();
            fStream.Close();



            buttonStreamToWSQ.Enabled = true;

        }

        private void buttonStreamToWSQ_Click(object sender, EventArgs e)
        {


            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "WSQ Files (*.wsq)|*.wsq";
            sfd.FilterIndex = 1;
            if (sfd.ShowDialog() != DialogResult.OK)
            {
                return;
            }


            bitrate = 0.75;
            ppi = 500;
            //comment_text = "";
            comment_text = "Cognaxon";


            input_data_stream2 = new byte[width * height];
            int row, row2, pixel_number, pixel_number2;

            // MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
            for (int y = 0; y < height; y++)
            {
                row = width * y;
                row2 = width * (height - y - 1);
                for (int x = 0; x < width; x++)
                {
                    pixel_number = row + x;
                    pixel_number2 = row2 + (width - x - 1);

                    input_data_stream2[pixel_number2] = output_data_stream[pixel_number];
                }
            }


            int compressedLength;
            WSQ_library_native_methods.pWSQ_encode_stream(input_data_stream2, width, height,
                bitrate, ppi, comment_text, out output_data_stream2, out compressedLength);


            FileStream fStream = new FileStream(sfd.FileName, FileMode.Create);
            BinaryWriter bw = new BinaryWriter(fStream);

            bw.Write(output_data_stream2);
            bw.Close();
            fStream.Close();
            MessageBox.Show("Memory stream was compressed into another memory stream and saved to WSQ file.\nNow please press button \"Open\", select the saved file, open it and have a look at the\nresults of memory stream processing. The processed image is mirrored/flipped\n(UP<->DOWN and LEFT<->RIGHT).");



        }
    }
}
